##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------

##
## NEW MACROS
##

## 16 colours palette
PALETTE=0 1 2 3 6 9 14 12 13 15 16 18 21 24 25 26

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_FOLDER      , src/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))

$(eval $(call IMG2SP, SET_FOLDER      , src/sprites))
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))

$(eval $(call IMG2SP, CONVERT         , img/main_character.png , 0, 0, sp_main_character))
$(eval $(call IMG2SP, CONVERT         , img/main_character_down.png , 0, 0, sp_main_character_down))
$(eval $(call IMG2SP, CONVERT         , img/main_character_left.png , 14, 16, sp_main_character_left))
$(eval $(call IMG2SP, CONVERT         , img/main_character_right.png , 14, 16, sp_main_character_right))
$(eval $(call IMG2SP, CONVERT         , img/main_character_jump.png , 14, 16, sp_main_character_jump))
$(eval $(call IMG2SP, CONVERT         , img/main_character_jump_left.png , 14, 16, sp_main_character_jump_left))
$(eval $(call IMG2SP, CONVERT         , img/main_character_jump_right.png , 14, 16, sp_main_character_jump_right))
$(eval $(call IMG2SP, CONVERT         , img/pumpkin_enemy.png , 14, 16, sp_pumpkin_enemy))
$(eval $(call IMG2SP, CONVERT         , img/candy.png , 14, 12, sp_candy))
$(eval $(call IMG2SP, CONVERT         , img/door_open.png , 14, 16, sp_door_open))
$(eval $(call IMG2SP, CONVERT         , img/door_close.png , 0, 0, sp_door_close))
$(eval $(call IMG2SP, CONVERT         , img/menu1.png , 80, 100, img_menu))
$(eval $(call IMG2SP, CONVERT         , img/controls_instruction.png , 0, 0, img_controls))

$(eval $(call IMG2SP, SET_IMG_FORMAT  ,  zgtiles ))
$(eval $(call IMG2SP, CONVERT         , img/mapa_tiles.png , 8, 8, mapatiles))
