;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Component Array Data Structure Include
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Generation of a data structure and an array of type components
;;    A macro to create every data structure 
;;    needed to manage an array of identical components.
;; GENERATED LABELS:
;;      T_num: a byte to count the number of elements in the array
;;      T_pend: a word to store the pointer to the end of the array
;;              which is a first free element
;;      T_array: the array itself
;; INPUTS:
;;      _Tname: name of the component type
;;      _N: size of the array to be created
;;      _DefineTypeMacroDefault: macro to be called to generate a default component
;;
.macro DefineComponentArrayStructure _Tname, _N, _ComponentSize
   _Tname'_num:    .db 0               ;; Number of defined elements
   _Tname'_pend:   .dw _Tname'_array   ;; Pointer to the end of the array
   _Tname'_array:                      ;; Array of elements of the same type
      .ds _N * _ComponentSize
   _Tname'_zero_type_at_the_end:
      .ds 1
.endm
