;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ANIMATIONS MANAGER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.include "cmp/macros_entity.h.s"

.include "assets/assets.h.s"
.include "cpctelera.h.s"

;; DURL
;; 0000 inactive
;; 0001 left
;; 0010 right
;; 0011 --
;; 0100 jump
;; 0101 jump-left
;; 0110 jump-right
;; 0111 --
;; 1000 down
;; 1001 down-left
;; 1010 down-right
_animations_array:
   .dw _main_char_inactive
   .dw _main_char_moving_left
   .dw _main_char_moving_right
   .dw nullptr
   .dw _main_char_jump
   .dw _main_char_jump_left
   .dw _main_char_jump_right
   .dw nullptr
   .dw _main_char_down 
   .dw _main_char_jump_left  ;;down-left
   .dw _main_char_jump_right ;;down-right

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAN_ANIMATIONS_GETANIMHL
;;    Returns corresponding animation to given anim status
;; INPUT:
;;    B: Animation Status 
;; RETURN: 
;;    HL: Pointer to animation
;; DESTROYS: HL, AF
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
man_animations_getAnimHL::
   ld    hl, #_animations_array
   ld    a, b
   add   a
   add_hl_a

   ld    a, (hl)
   inc   hl
   ld    h, (hl)
   ld    l, a

   ret
   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN CHARACTER ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
_main_char_inactive::
   .dw _sp_main_character
   .dw nullptr
   .dw _main_char_inactive

_main_char_jump::
   .dw _sp_main_character_jump
   .dw nullptr
   .dw _main_char_jump

_main_char_down::
   .dw _sp_main_character_down
   .dw nullptr
   .dw _main_char_down

_main_char_moving_left::
   .dw _sp_main_character_left_0
   .dw _sp_main_character_left_1
   .dw _sp_main_character_left_2
   .dw nullptr
   .dw _main_char_moving_left

_main_char_moving_right::
   .dw _sp_main_character_right_0
   .dw _sp_main_character_right_1
   .dw _sp_main_character_right_2
   .dw nullptr
   .dw _main_char_moving_right

_main_char_jump_left::
   .dw _sp_main_character_jump_left_0
   .dw _sp_main_character_jump_left_1
   .dw _sp_main_character_jump_left_2
   .dw nullptr
   .dw _main_char_jump_left

_main_char_jump_right::
   .dw _sp_main_character_jump_right_0
   .dw _sp_main_character_jump_right_1
   .dw _sp_main_character_jump_right_2
   .dw nullptr
   .dw _main_char_jump_right

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PUMPKIN ENEMY ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
_enemy_moving::
   .dw _sp_pumpkin_enemy_0
   .dw _sp_pumpkin_enemy_1
   .dw nullptr
   .dw _enemy_moving

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CANDY ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
_candy_moving::
   .dw _sp_candy_0
   .dw _sp_candy_1
   .dw nullptr
   .dw _candy_moving

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DOOR ANIMATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
_door_opened::
   .dw _sp_door_open_0
   .dw _sp_door_open_1
   .dw nullptr
   .dw _door_opened

_door_closed::
   .dw _sp_door_close
   .dw nullptr
   .dw _door_closed
