;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.include "cmp/macros_entity.h.s"

.include "man/entity.h.s"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.module AI_Control_System
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.area _DATA
.area _CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SYS_AI_CONTROL_INIT
;;    Initialize Animation system
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sys_ai_control_init::
   ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SYS_AI_CONTROL_UPDATE_ONE_ENTITY
;;    Updates an AI entity
;; INPUT:
;;    IX: Pointer to AI Entity, it is not the end of the array
;; DESTROYS: AF, DE, HL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sys_ai_control_update_one_entity:
   ld    a, e_x(ix)
   cp    e_route_init(ix)
   jr    z, _move_enemy_from_left_corner
   cp    e_route_fin(ix)
   jr    z, _move_enemy_from_right_corner
   jr    _move_enemy
_move_enemy_from_left_corner:
   ld    e_vx(ix), #1
   jr    _move_enemy

_move_enemy_from_right_corner:
   ld    e_vx(ix), #-1
   jr    _move_enemy
   
_move_enemy:
   ld    a, e_x(ix)
   add   e_vx(ix)
   ld    e_x(ix), a

   ;;----------------------------------------------------
   ;; HL has an applied function. hl and de have to 
   ;; be exchanged so not to lose their values.
   ;;
   ex    de, hl                  ;; DE = applied function
   ;;----------------------------------------------------
   ;; Recover stored way_back(de) into hl, then they will be
   ;; exchanged. DE = applied function
   ;;
   pop   hl                      ;; HL = way back
   jp    (hl)	     

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SYS_AI_CONTROL_UPDATE
;;    Updates all AI entities
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sys_ai_control_update::
   ld    c, #e_type_ai_mask
   ld    hl, #sys_ai_control_update_one_entity
   call  man_entity_forall_matching_types
   ret
