;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.include "cmp/macros_entity.h.s"

.include "man/entity.h.s"
.include "man/game.h.s"

.include "sys/input.h.s"
.include "sys/collisions.h.s"

.include "cpctelera.h.s"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.module Input_System
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.area _DATA
.area _CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PLAYER JUMP STATUS 
;; 0x02 if movement is blocked
;; 0x01 if movement is available
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 playerStatus::
  .db 1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SYS_INPUT_INIT
;;    Initializes the input system
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sys_input_init::
   ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SYS_INPUT_UPDATE
;;    Receives keyboard inputs and applies them
;;    to keyboard-controlled entities.
;; DESTROYS: AF, BC, DE, HL, IX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sys_input_update::
   ;;----------------------------------------------------
   ;; IX = Pointer to the entity array
   ;;
   call  man_entity_getArray

   ;;----------------------------------------------------
   ;; Reset velocities
   ;;
   ld    e_vx(ix), #0
   ld    e_vy(ix), #0

   ;;----------------------------------------------------
   ;; Scan the keyboard
   ;;
   call  cpct_scanKeyboard_f_asm

   ;;----------------------------------------------------
   ;; Check for movement keys
   ;;
   ld    hl, #Key_O
   call  cpct_isKeyPressed_asm
   jr    z, O_NotPressed

O_Pressed:
   ld    e_vx(ix), #-1     ;; go left

O_NotPressed:
   ld    hl, #Key_P
   call  cpct_isKeyPressed_asm
   jr    z, P_NotPressed

P_Pressed:
   ld    e_vx(ix), #1      ;; go right

P_NotPressed:
   ld    hl, #Key_Q
   call  cpct_isKeyPressed_asm
   jr    z, Q_NotPressed

Q_Pressed:
   ld    a, (#playerStatus)
   cp    #1
   jr    nz, Q_NotPressed

   ld    e_vy(ix), #-30 ;; this number is the heidth of the jump

   ld    hl, #playerStatus
   ld    (hl), #2

Q_NotPressed:
   ret
   